--- //depot/vendor/freebsd/src/sys/kern/uipc_syscalls.c	2004/07/17 21:10:41
+++ //depot/user/rwatson/netperf/sys/kern/uipc_syscalls.c	2004/07/19 22:28:50
@@ -278,6 +278,7 @@
 	error = fgetsock(td, uap->s, &head, &fflag);
 	if (error)
 		goto done2;
+	/* Unlocked read. */
 	if ((head->so_options & SO_ACCEPTCONN) == 0) {
 		error = EINVAL;
 		goto done;
@@ -285,6 +286,10 @@
 	error = falloc(td, &nfp, &fd);
 	if (error)
 		goto done;
+	/*
+	 * Unlocked reads.
+	 * XXXRW: Dubious use of so->so_error.
+	 */
 	ACCEPT_LOCK();
 	if ((head->so_state & SS_NBIO) && TAILQ_EMPTY(&head->so_comp)) {
 		ACCEPT_UNLOCK();
@@ -333,6 +338,11 @@
 	/* An extra reference on `nfp' has been held for us by falloc(). */
 	td->td_retval[0] = fd;
 
+	/*
+	 * XXXRW: Might make life simpler to grab the socket buffer lock
+	 * here so it's held when KNOTE() calls back into the socket
+	 * code.
+	 */
 	/* connection has been removed from the listen queue */
 	KNOTE(&head->so_rcv.sb_sel.si_note, 0);
 
@@ -482,6 +492,7 @@
 	NET_LOCK_GIANT();
 	if ((error = fgetsock(td, fd, &so, NULL)) != 0)
 		goto done2;
+	/* XXXRW: so_state locking? */
 	if (so->so_state & SS_ISCONNECTING) {
 		error = EALREADY;
 		goto done1;
@@ -496,12 +507,14 @@
 	error = soconnect(so, sa, td);
 	if (error)
 		goto bad;
+	/* XXXRW: so_state locking? */
 	if ((so->so_state & SS_NBIO) && (so->so_state & SS_ISCONNECTING)) {
 		error = EINPROGRESS;
 		goto done1;
 	}
 	s = splnet();
 	SOCK_LOCK(so);
+	/* XXXRW: so_state locking? */
 	while ((so->so_state & SS_ISCONNECTING) && so->so_error == 0) {
 		error = msleep(&so->so_timeo, SOCK_MTX(so), PSOCK | PCATCH,
 		    "connec", 0);
@@ -518,6 +531,7 @@
 	SOCK_UNLOCK(so);
 	splx(s);
 bad:
+	/* XXXRW: so_state locking? */
 	if (!interrupted)
 		so->so_state &= ~SS_ISCONNECTING;
 	if (error == ERESTART)
@@ -1481,6 +1495,7 @@
 	NET_LOCK_GIANT();
 	if ((error = fgetsock(td, uap->fdes, &so, NULL)) != 0)
 		goto done2;
+	/* XXXRW: so_state locking? */
 	if ((so->so_state & (SS_ISCONNECTED|SS_ISCONFIRMING)) == 0) {
 		error = ENOTCONN;
 		goto done1;
@@ -1722,6 +1737,7 @@
 		error = EINVAL;
 		goto done;
 	}
+	/* XXXRW: so_state locking? */
 	if ((so->so_state & SS_ISCONNECTED) == 0) {
 		error = ENOTCONN;
 		goto done;
@@ -1813,6 +1829,7 @@
 		 * before going to the extra work of constituting the sf_buf.
 		 */
 		SOCKBUF_LOCK(&so->so_snd);
+		/* XXXRW: so_state locking? */
 		if ((so->so_state & SS_NBIO) && sbspace(&so->so_snd) <= 0) {
 			if (so->so_snd.sb_state & SBS_CANTSENDMORE)
 				error = EPIPE;
@@ -1878,6 +1895,7 @@
 			 * Get the page from backing store.
 			 */
 			bsize = vp->v_mount->mnt_stat.f_iosize;
+			mtx_lock(&Giant);	/* VFS */
 			vn_lock(vp, LK_SHARED | LK_NOPAUSE | LK_RETRY, td);
 			/*
 			 * XXXMAC: Because we don't have fp->f_cred here,
@@ -1889,6 +1907,7 @@
 			    IO_VMIO | ((MAXBSIZE / bsize) << IO_SEQSHIFT),
 			    td->td_ucred, NOCRED, &resid, td);
 			VOP_UNLOCK(vp, 0, td);
+			mtx_unlock(&Giant);	/* VFS */
 			if (error)
 				VM_OBJECT_LOCK(obj);
 			vm_page_lock_queues();
@@ -1999,6 +2018,7 @@
 		 * after checking the connection state above in order to avoid
 		 * a race condition with sbwait().
 		 */
+		/* XXXRW: so_state locking? */
 		if (sbspace(&so->so_snd) < so->so_snd.sb_lowat) {
 			if (so->so_state & SS_NBIO) {
 				m_freem(m);
--- //depot/vendor/freebsd/src/sys/kern/uipc_usrreq.c	2004/08/14 03:45:31
+++ //depot/user/rwatson/netperf/sys/kern/uipc_usrreq.c	2004/08/14 16:02:22
@@ -107,11 +107,14 @@
 static int
 uipc_abort(struct socket *so)
 {
-	struct unpcb *unp = sotounpcb(so);
+	struct unpcb *unp;
 
-	if (unp == NULL)
+	UNP_LOCK();
+	unp = sotounpcb(so);
+	if (unp == NULL) {
+		UNP_UNLOCK();
 		return (EINVAL);
-	UNP_LOCK();
+	}
 	unp_drop(unp, ECONNABORTED);
 	unp_detach(unp);	/* NB: unlocks */
 	SOCK_LOCK(so);
@@ -122,26 +125,35 @@
 static int
 uipc_accept(struct socket *so, struct sockaddr **nam)
 {
-	struct unpcb *unp = sotounpcb(so);
 	const struct sockaddr *sa;
+	struct unpcb *unp;
+	int error;
 
-	if (unp == NULL)
-		return (EINVAL);
-
 	/*
 	 * Pass back name of connected socket,
 	 * if it was bound and we are still connected
 	 * (our peer may have closed already!).
 	 */
+	error = 0;
 	*nam = malloc(sizeof(struct sockaddr_un), M_SONAME, M_WAITOK);
 	UNP_LOCK();
+	unp = sotounpcb(so);
+	if (unp == NULL) {
+		error = EINVAL;
+		goto out;
+	}
 	if (unp->unp_conn != NULL && unp->unp_conn->unp_addr != NULL)
 		sa = (struct sockaddr *) unp->unp_conn->unp_addr;
 	else
 		sa = &sun_noname;
 	bcopy(sa, *nam, sa->sa_len);
+out:
 	UNP_UNLOCK();
-	return (0);
+	if (error) {
+		free(*nam, M_SONAME);
+		*nam = NULL;
+	}
+	return (error);
 }
 
 static int
@@ -149,6 +161,9 @@
 {
 	struct unpcb *unp = sotounpcb(so);
 
+	/*
+	 * XXXRW: How could unp be non-NULL here?
+	 */
 	if (unp != NULL)
 		return (EISCONN);
 	return (unp_attach(so));
@@ -157,12 +172,20 @@
 static int
 uipc_bind(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
-	struct unpcb *unp = sotounpcb(so);
+	struct unpcb *unp;
+	int error;
 
-	if (unp == NULL)
-		return (EINVAL);
-
-	return (unp_bind(unp, nam, td));
+	error = 0;
+	UNP_LOCK();
+	unp = sotounpcb(so);
+	if (unp == NULL) {
+		error = EINVAL;
+		goto out;
+	}
+	error = unp_bind(unp, nam, td);
+out:
+	UNP_UNLOCK();
+	return (error);
 }
 
 static int
@@ -173,6 +196,7 @@
 
 	KASSERT(td == curthread, ("uipc_connect: td != curthread"));
 
+	error = 0;
 	UNP_LOCK();
 	unp = sotounpcb(so);
 	if (unp == NULL) {
@@ -188,14 +212,18 @@
 int
 uipc_connect2(struct socket *so1, struct socket *so2)
 {
-	struct unpcb *unp = sotounpcb(so1);
+	struct unpcb *unp;
 	int error;
 
-	if (unp == NULL)
-		return (EINVAL);
-
+	error = 0;
 	UNP_LOCK();
+	unp = sotounpcb(so1);
+	if (unp == NULL) {
+		error = EINVAL;
+		goto out;
+	}
 	error = unp_connect2(so1, so2);
+out:
 	UNP_UNLOCK();
 	return (error);
 }
@@ -205,12 +233,14 @@
 static int
 uipc_detach(struct socket *so)
 {
-	struct unpcb *unp = sotounpcb(so);
+	struct unpcb *unp;
 
-	if (unp == NULL)
+	UNP_LOCK();
+	unp = sotounpcb(so);
+	if (unp == NULL) {
+		UNP_UNLOCK();
 		return (EINVAL);
-
-	UNP_LOCK();
+	}
 	unp_detach(unp);	/* NB: unlocks unp */
 	return (0);
 }
@@ -218,11 +248,14 @@
 static int
 uipc_disconnect(struct socket *so)
 {
-	struct unpcb *unp = sotounpcb(so);
+	struct unpcb *unp;
 
-	if (unp == NULL)
+	UNP_LOCK();
+	unp = sotounpcb(so);
+	if (unp == NULL) {
+		UNP_UNLOCK();
 		return (EINVAL);
-	UNP_LOCK();
+	}
 	unp_disconnect(unp);
 	UNP_UNLOCK();
 	return (0);
@@ -231,13 +264,17 @@
 static int
 uipc_listen(struct socket *so, struct thread *td)
 {
-	struct unpcb *unp = sotounpcb(so);
+	struct unpcb *unp;
 	int error;
 
-	if (unp == NULL || unp->unp_vnode == NULL)
-		return (EINVAL);
 	UNP_LOCK();
+	unp = sotounpcb(so);
+	if (unp == NULL || unp->unp_vnode == NULL) {
+		error = EINVAL;
+		goto out;
+	}
 	error = unp_listen(unp, td);
+out:
 	UNP_UNLOCK();
 	return (error);
 }
@@ -245,13 +282,18 @@
 static int
 uipc_peeraddr(struct socket *so, struct sockaddr **nam)
 {
-	struct unpcb *unp = sotounpcb(so);
+	struct unpcb *unp;
 	const struct sockaddr *sa;
 
-	if (unp == NULL)
-		return (EINVAL);
 	*nam = malloc(sizeof(struct sockaddr_un), M_SONAME, M_WAITOK);
 	UNP_LOCK();
+	unp = sotounpcb(so);
+	if (unp == NULL) {
+		UNP_UNLOCK();
+		free(*nam, M_SONAME);
+		*nam = NULL;
+		return (EINVAL);
+	}
 	if (unp->unp_conn != NULL && unp->unp_conn->unp_addr!= NULL)
 		sa = (struct sockaddr *) unp->unp_conn->unp_addr;
 	else {
@@ -270,21 +312,26 @@
 static int
 uipc_rcvd(struct socket *so, int flags)
 {
-	struct unpcb *unp = sotounpcb(so);
+	struct unpcb *unp;
 	struct socket *so2;
 	u_long newhiwat;
 
-	if (unp == NULL)
-		return (EINVAL);
-	UNP_LOCK();
 	switch (so->so_type) {
 	case SOCK_DGRAM:
 		panic("uipc_rcvd DGRAM?");
 		/*NOTREACHED*/
 
 	case SOCK_STREAM:
-		if (unp->unp_conn == NULL)
-			break;
+		UNP_LOCK();
+		unp = sotounpcb(so);
+		if (unp == NULL) {
+			UNP_UNLOCK();
+			return (EINVAL);
+		}
+		if (unp->unp_conn == NULL) {
+			UNP_UNLOCK();
+			return (0);
+		}
 		so2 = unp->unp_conn->unp_socket;
 		SOCKBUF_LOCK(&so2->so_snd);
 		SOCKBUF_LOCK(&so->so_rcv);
@@ -299,14 +346,22 @@
 		(void)chgsbsize(so2->so_cred->cr_uidinfo, &so2->so_snd.sb_hiwat,
 		    newhiwat, RLIM_INFINITY);
 		unp->unp_cc = so->so_rcv.sb_cc;
+
+		/*
+		 * XXXRW: It would be desirable to release the UNP lock
+		 * before doing the socket wakeup.  However, to do that we
+		 * need to acquire a reference to so2 so it doesn't evaporate
+		 * if the peer closes it; this may be more expensive than the
+		 * wakeup causing contention on the socket mutex.
+		 */
 		SOCKBUF_UNLOCK(&so->so_rcv);
 		sowwakeup_locked(so2);
+		UNP_UNLOCK();
 		break;
 
 	default:
 		panic("uipc_rcvd unknown socktype");
 	}
-	UNP_UNLOCK();
 	return (0);
 }
 
@@ -317,10 +372,17 @@
 	  struct mbuf *control, struct thread *td)
 {
 	int error = 0;
-	struct unpcb *unp = sotounpcb(so);
+	struct unpcb *unp;
 	struct socket *so2;
 	u_long newhiwat;
 
+	/*
+	 * XXXRW: We do the basic checks before acquiring the UNP lock in
+	 * order to avoid paying the cost if it's not needed.  We have to
+	 * re-do the sotounpcb() call once we do acquire it since that may
+	 * have changed.
+	 */
+	unp = sotounpcb(so);
 	if (unp == NULL) {
 		error = EINVAL;
 		goto release;
@@ -334,6 +396,13 @@
 		goto release;
 
 	UNP_LOCK();
+	unp = sotounpcb(so);
+	if (unp == NULL) {
+		UNP_UNLOCK();
+		error = EINVAL;
+		goto dispose_release;
+	}
+
 	switch (so->so_type) {
 	case SOCK_DGRAM:
 	{
@@ -378,6 +447,7 @@
 		 * Note: A better implementation would complain
 		 * if not equal to the peer's address.
 		 */
+		/* Unlocked read. */
 		if ((so->so_state & SS_ISCONNECTED) == 0) {
 			if (nam != NULL) {
 				error = unp_connect(so, nam, td);
@@ -389,6 +459,7 @@
 			}
 		}
 
+		/* Unlocked read. */
 		if (so->so_snd.sb_state & SBS_CANTSENDMORE) {
 			error = EPIPE;
 			break;
@@ -434,6 +505,7 @@
 	}
 	UNP_UNLOCK();
 
+dispose_release:
 	if (control != NULL && error != 0)
 		unp_dispose(control);
 
@@ -448,56 +520,79 @@
 static int
 uipc_sense(struct socket *so, struct stat *sb)
 {
-	struct unpcb *unp = sotounpcb(so);
+	struct unpcb *unp;
 	struct socket *so2;
+	int error;
 
-	if (unp == NULL)
-		return (EINVAL);
+	error = 0;
 	UNP_LOCK();
+	unp = sotounpcb(so);
+	if (unp == NULL) {
+		error = EINVAL;
+		goto out;
+	}
 	sb->st_blksize = so->so_snd.sb_hiwat;
 	if (so->so_type == SOCK_STREAM && unp->unp_conn != NULL) {
 		so2 = unp->unp_conn->unp_socket;
+		/* Unlocked read. */
 		sb->st_blksize += so2->so_rcv.sb_cc;
 	}
 	sb->st_dev = NODEV;
 	if (unp->unp_ino == 0)
 		unp->unp_ino = (++unp_ino == 0) ? ++unp_ino : unp_ino;
 	sb->st_ino = unp->unp_ino;
+out:
 	UNP_UNLOCK();
-	return (0);
+	return (error);
 }
 
 static int
 uipc_shutdown(struct socket *so)
 {
-	struct unpcb *unp = sotounpcb(so);
+	struct unpcb *unp;
+	int error;
 
-	if (unp == NULL)
-		return (EINVAL);
+	error = 0;
 	UNP_LOCK();
+	unp = sotounpcb(so);
+	if (unp == NULL) {
+		error = EINVAL;
+		goto out;
+	}
 	socantsendmore(so);
 	unp_shutdown(unp);
+out:
 	UNP_UNLOCK();
-	return (0);
+	return (error);
 }
 
 static int
 uipc_sockaddr(struct socket *so, struct sockaddr **nam)
 {
-	struct unpcb *unp = sotounpcb(so);
+	struct unpcb *unp;
 	const struct sockaddr *sa;
+	int error;
 
-	if (unp == NULL)
-		return (EINVAL);
 	*nam = malloc(sizeof(struct sockaddr_un), M_SONAME, M_WAITOK);
+	error = 0;
 	UNP_LOCK();
+	unp = sotounpcb(so);
+	if (unp == NULL) {
+		error = EINVAL;
+		goto out;
+	}
 	if (unp->unp_addr != NULL)
 		sa = (struct sockaddr *) unp->unp_addr;
 	else
 		sa = &sun_noname;
 	bcopy(sa, *nam, sa->sa_len);
+out:
 	UNP_UNLOCK();
-	return (0);
+	if (error) {
+		free(*nam, M_SONAME);
+		*nam = NULL;
+	}
+	return (error);
 }
 
 struct pr_usrreqs uipc_usrreqs = {
@@ -513,7 +608,7 @@
 	struct socket *so;
 	struct sockopt *sopt;
 {
-	struct unpcb *unp = sotounpcb(so);
+	struct unpcb *unp;
 	struct xucred xu;
 	int error;
 
@@ -523,6 +618,12 @@
 		case LOCAL_PEERCRED:
 			error = 0;
 			UNP_LOCK();
+			unp = sotounpcb(so);
+			if (unp == NULL) {
+				UNP_UNLOCK();
+				error = EINVAL;
+				break;
+			}
 			if (unp->unp_flags & UNP_HAVEPC)
 				xu = unp->unp_peercred;
 			else {
@@ -611,13 +712,14 @@
 	unp->unp_socket = so;
 
 	UNP_LOCK();
+	KASSERT(so->so_pcb == NULL, ("unp_attach(): so->so_pcb != NULL"));
 	unp->unp_gencnt = ++unp_gencnt;
 	unp_count++;
 	LIST_INSERT_HEAD(so->so_type == SOCK_DGRAM ? &unp_dhead
 			 : &unp_shead, unp, unp_link);
+	so->so_pcb = unp;
 	UNP_UNLOCK();
 
-	so->so_pcb = unp;
 	return (0);
 }
 
@@ -657,9 +759,9 @@
 		 * gets them (resulting in a "panic: closef: count < 0").
 		 */
 		sorflush(unp->unp_socket);
-		unp_gc();
-	}
-	UNP_UNLOCK();
+		unp_gc();	/* Will unlock UNP. */
+	} else
+		UNP_UNLOCK();
 	if (unp->unp_addr != NULL)
 		FREE(unp->unp_addr, M_SONAME);
 	uma_zfree(unp_zone, unp);
@@ -684,6 +786,8 @@
 	struct nameidata nd;
 	char *buf;
 
+	UNP_LOCK_ASSERT();
+
 	/*
 	 * XXXRW: This test-and-set of unp_vnode is non-atomic; the
 	 * unlocked read here is fine, but the value of unp_vnode needs
@@ -697,6 +801,8 @@
 	if (namelen <= 0)
 		return (EINVAL);
 
+	UNP_UNLOCK();
+
 	buf = malloc(namelen + 1, M_TEMP, M_WAITOK);
 	strlcpy(buf, soun->sun_path, namelen + 1);
 
@@ -745,6 +851,12 @@
 	ASSERT_VOP_LOCKED(vp, "unp_bind");
 	soun = (struct sockaddr_un *)sodupsockaddr(nam, M_WAITOK);
 	UNP_LOCK();
+	/*
+	 * XXXRW: we actually need to retest unp here and make sure that we
+	 * didn't race with another thread operating on this socket.  In
+	 * particular, we must check unp != NULL, and that unp->unp_vnode ==
+	 * NULL.
+	 */
 	vp->v_socket = unp->unp_socket;
 	unp->unp_vnode = vp;
 	unp->unp_addr = soun;
@@ -754,6 +866,7 @@
 done:
 	mtx_unlock(&Giant);
 	free(buf, M_TEMP);
+	UNP_LOCK();
 	return (error);
 }
 
@@ -802,6 +915,11 @@
 		goto bad;
 	mtx_unlock(&Giant);
 	UNP_LOCK();
+	/*
+	 * XXXRW: We actually need to retest our assumptions here to make
+	 * sure we didn't race with another thread operating on this UNIX
+	 * domain socket.  In particular, that unp != NULL.
+	 */
 	unp = sotounpcb(so);
 	if (unp == NULL) {
 		/*
@@ -1401,6 +1519,11 @@
 	return (error);
 }
 
+/*
+ * XXXRW: unp_defer is thread-local during garbage collection, and does not
+ * require explicit synchronization.  unp_gcing prevents other threads from
+ * entering garbage collection, and perhaps should be an sx lock instead.
+ */
 static int	unp_defer, unp_gcing;
 
 static void
@@ -1415,18 +1538,17 @@
 
 	UNP_LOCK_ASSERT();
 
-	if (unp_gcing)
+	if (unp_gcing) {
+		UNP_UNLOCK();
 		return;
+	}
 	unp_gcing = 1;
 	unp_defer = 0;
+	UNP_UNLOCK();
 	/*
 	 * before going through all this, set all FDs to
 	 * be NOT defered and NOT externally accessible
 	 */
-	/*
-	 * XXXRW: Acquiring a sleep lock while holding UNP
-	 * mutex cannot be a good thing.
-	 */
 	sx_slock(&filelist_lock);
 	LIST_FOREACH(fp, &filehead, f_list)
 		fp->f_gcflag &= ~(FMARK|FDEFER);
@@ -1497,6 +1619,9 @@
 				 * of a signal.  If sbwait does return
 				 * an error, we'll go into an infinite
 				 * loop.  Delete all of this for now.
+				 *
+				 * XXXRW: We will need to lock the socket
+				 * buffer here if we enable this code.
 				 */
 				(void) sbwait(&so->so_rcv);
 				goto restart;
@@ -1508,6 +1633,9 @@
 			 * to see if we hold any file descriptors in its
 			 * message buffers. Follow those links and mark them
 			 * as accessible too.
+			 *
+			 * XXXRW: We hold the socket buffer lock to prevent
+			 * the mbuf chain of interest from changing.
 			 */
 			SOCKBUF_LOCK(&so->so_rcv);
 			unp_scan(so->so_rcv.sb_mb, unp_mark);
--- //depot/vendor/freebsd/src/sys/kern/vfs_aio.c	2004/08/13 17:45:22
+++ //depot/user/rwatson/netperf/sys/kern/vfs_aio.c	2004/08/14 16:02:22
@@ -168,6 +168,9 @@
 SYSCTL_INT(_vfs_aio, OID_AUTO, max_buf_aio, CTLFLAG_RW, &max_buf_aio, 0,
     "Maximum buf aio requests per process (stored in the process)");
 
+/*
+ * struct aiocblist describes a specific AIO I/O request (job).
+ */
 struct aiocblist {
 	TAILQ_ENTRY(aiocblist) list;	/* List of jobs */
 	TAILQ_ENTRY(aiocblist) plist;	/* List of jobs for proc */
@@ -196,6 +199,10 @@
 #define AIOP_FREE	0x1			/* proc on free queue */
 #define AIOP_SCHED	0x2			/* proc explicitly scheduled */
 
+/*
+ * struct aiothreadlist is the per-worker thread data structure, and is
+ * allocated by the thread when it is created.
+ */
 struct aiothreadlist {
 	int aiothreadflags;			/* AIO proc flags */
 	TAILQ_ENTRY(aiothreadlist) list;	/* List of processes */
@@ -219,7 +226,9 @@
 #define	LIOJ_SIGNAL_POSTED	0x2	/* signal has been posted */
 
 /*
- * per process aio data structure
+ * struct kaiinfo is the per-process aio data structure.  This is allocated
+ * and hung off of p->p_aioinfo by aio_init_aioinfo() the first time a
+ * process makes use of the AIO facility.
  */
 struct kaioinfo {
 	int	kaio_flags;		/* per process kaio flags */
@@ -1223,6 +1232,8 @@
 
 /*
  * Wake up aio requests that may be serviceable now.
+ *
+ * XXXRW: This doesn't look MPSAFE at all.
  */
 static void
 aio_swake_cb(struct socket *so, struct sockbuf *sb)
--- //depot/vendor/freebsd/src/sys/net/if.c	2004/08/06 09:10:25
+++ //depot/user/rwatson/netperf/sys/net/if.c	2004/08/06 20:41:48
@@ -264,6 +264,14 @@
 	if_clone_init();
 }
 
+/*
+ * Grow the global ifindex_table by a power of two over the current side.
+ * Note that this call assumes ifindex_table (and hence the if_indexentry
+ * entries in it) can be relocated in memory without causing a problem.
+ *
+ * XXXRW: Locking assertion needed here?  What protects against untimely
+ * indirection through ifindex_table?  Note M_WAITOK.
+ */
 static void
 if_grow(void)
 {
@@ -280,6 +288,10 @@
 	ifindex_table = e;
 }
 
+/*
+ * if_check() scans the list of registered network interfaces to check that
+ * initialization-time invariants are met.
+ */
 /* ARGSUSED*/
 static void
 if_check(void *dummy __unused)
@@ -306,6 +318,9 @@
 	if_slowtimo(0);
 }
 
+/*
+ * if_findindex  ... XXXRW: what?
+ */
 static int
 if_findindex(struct ifnet *ifp)
 {
@@ -319,6 +334,10 @@
 	case IFT_XETHER:
 	case IFT_ISO88025:
 	case IFT_L2VLAN:
+		/*
+		 * XXXRW: Assumes that arpcom always has its ifnet at the
+		 * head of its structure.
+		 */
 		snprintf(eaddr, 18, "%6D", IFP2AC(ifp)->ac_enaddr, ":");
 		break;
 	default:
@@ -367,6 +386,10 @@
 	struct sockaddr_dl *sdl;
 	struct ifaddr *ifa;
 
+	/*
+	 * XXXRW: Shouldn't we add to the global list only once the ifnet
+	 * is ready for use?
+	 */
 	TASK_INIT(&ifp->if_starttask, 0, if_start_deferred, ifp);
 	IF_AFDATA_LOCK_INIT(ifp);
 	ifp->if_afdata_initialized = 0;
--- //depot/vendor/freebsd/src/sys/net/if_ethersubr.c	2004/07/27 23:25:38
+++ //depot/user/rwatson/netperf/sys/net/if_ethersubr.c	2004/08/05 04:24:12
@@ -615,9 +615,6 @@
 	}
 
 	ether_demux(ifp, m);
-	/* First chunk of an mbuf contains good entropy */
-	if (harvest.ethernet)
-		random_harvest(m, 16, 3, 0, RANDOM_NET);
 }
 
 /*
--- //depot/vendor/freebsd/src/sys/net/if_gif.c	2004/07/15 08:30:31
+++ //depot/user/rwatson/netperf/sys/net/if_gif.c	2004/07/15 22:19:17
@@ -89,6 +89,10 @@
  * gif_mtx protects the global gif_softc_list.
  * XXX: Per-softc locking is still required.
  */
+/*
+ * XXXRW: Note that gif_mtx only protects global gif-related data, not
+ * per-softc data.  See also netinet/in_gif.c for locking needs.
+ */
 static struct mtx gif_mtx;
 static MALLOC_DEFINE(M_GIF, "gif", "Generic Tunnel Interface");
 static LIST_HEAD(, gif_softc) gif_softc_list;
@@ -501,6 +505,9 @@
 }
 
 /* XXX how should we handle IPv6 scope on SIOC[GS]IFPHYADDR? */
+/*
+ * XXXRW: per-gif softc locking required.
+ */
 int
 gif_ioctl(ifp, cmd, data)
 	struct ifnet *ifp;
@@ -757,8 +764,10 @@
 	int s;
 	int error = 0; 
 
+	/*
+	 * XXXRW: per-gif softc locking required.
+	 */
 	s = splnet();
-
 	mtx_lock(&gif_mtx);
 	LIST_FOREACH(sc2, &gif_softc_list, gif_list) {
 		if (sc2 == sc)
@@ -787,6 +796,9 @@
 	}
 	mtx_unlock(&gif_mtx);
 
+	/*
+	 * XXXRW: Lock gif softc fields.
+	 */
 	/* XXX we can detach from both, but be polite just in case */
 	if (sc->gif_psrc)
 		switch (sc->gif_psrc->sa_family) {
--- //depot/vendor/freebsd/src/sys/net/if_gre.c	2004/08/05 08:15:37
+++ //depot/user/rwatson/netperf/sys/net/if_gre.c	2004/08/05 21:29:14
@@ -95,7 +95,8 @@
 
 /*
  * gre_mtx protects all global variables in if_gre.c.
- * XXX: gre_softc data not protected yet.
+ *
+ * XXXRW: It does not protect softc-specific data.
  */
 struct mtx gre_mtx;
 static MALLOC_DEFINE(M_GRE, GRENAME, "Generic Routing Encapsulation");
--- //depot/vendor/freebsd/src/sys/net/if_gre.h	2004/03/22 16:06:54
+++ //depot/user/rwatson/netperf/sys/net/if_gre.h	2004/03/22 16:18:59
@@ -54,6 +54,12 @@
 	WCCP_V2
 } wccp_ver_t;
 
+/*
+ * XXXRW: softc fields need locking.
+ *
+ * XXXRW: gre's notion of a 'called' count is not MP-safe, as it assumes
+ * only one packet can be processed at a time.
+ */
 struct gre_softc {
 	struct ifnet sc_if;
 	LIST_ENTRY(gre_softc) sc_list;
--- //depot/vendor/freebsd/src/sys/net/if_sl.c	2004/08/06 22:45:32
+++ //depot/user/rwatson/netperf/sys/net/if_sl.c	2004/08/07 02:40:42
@@ -162,6 +162,7 @@
 #define	ABT_WINDOW	(ABT_COUNT*2+2)	/* in seconds - time to count */
 
 static LIST_HEAD(sl_list, sl_softc) sl_list;
+static struct mtx slip_mtx;
 
 #define FRAME_END	 	0xc0		/* Frame End */
 #define FRAME_ESCAPE		0xdb		/* Frame Esc */
@@ -182,7 +183,7 @@
 static int	slopen(struct cdev *, struct tty *);
 static int	sloutput(struct ifnet *,
 	    struct mbuf *, struct sockaddr *, struct rtentry *);
-static int	slstart(struct tty *);
+static int	slstart(struct tty *tp);
 
 static struct linesw slipdisc = {
 	.l_open =	slopen,
@@ -203,6 +204,7 @@
 { 
 	switch (type) { 
 	case MOD_LOAD: 
+		mtx_init(&slip_mtx, "slip_mtx", NULL, MTX_DEF);
 		ldisc_register(SLIPDISC, &slipdisc);
 		LIST_INIT(&sl_list);
 		break; 
@@ -224,6 +226,7 @@
 
 DECLARE_MODULE(if_sl, sl_mod, SI_SUB_PSEUDO, SI_ORDER_ANY);
 
+/* Locked using slip_mtx. */
 static int *st_unit_list;
 static size_t st_unit_max = 0;
 
@@ -232,6 +235,7 @@
 {
 	struct sl_softc *nc;
 
+	mtx_assert(&slip_mtx, MA_OWNED);
 	LIST_FOREACH(nc, &sl_list, sl_next) {
 		if (nc->sc_if.if_dunit == unit)
 			return (0);
@@ -245,6 +249,7 @@
 {
 	size_t i;
 
+	mtx_assert(&slip_mtx, MA_OWNED);
 	for (i = 0; i < st_unit_max; i++)
 		if (st_unit_list[i] == unit)
 			return 1;
@@ -257,6 +262,7 @@
 {
 	int *t;
 
+	mtx_assert(&slip_mtx, MA_OWNED);
 	if (slisstatic(unit))
 		return;
 
@@ -319,10 +325,12 @@
 	sc->sc_if.if_linkmib = sc;
 	sc->sc_if.if_linkmiblen = sizeof *sc;
 	mtx_init(&sc->sc_fastq.ifq_mtx, "sl_fastq", NULL, MTX_DEF);
+	mtx_init(&sc->sc_mtx, "slip sc_mtx", NULL, MTX_DEF);
 
 	/*
 	 * Find a suitable unit number.
 	 */
+	mtx_lock(&slip_mtx);
 	for (unit=0; ; unit++) {
 		if (slisstatic(unit))
 			continue;
@@ -332,6 +340,7 @@
 	}
 	if_initname(&sc->sc_if, "sl", unit);
 	LIST_INSERT_HEAD(&sl_list, sc, sl_next);
+	mtx_unlock(&slip_mtx);
 
 	if_attach(&sc->sc_if);
 	bpfattach(&sc->sc_if, DLT_SLIP, SLIP_HDRLEN);
@@ -391,10 +400,20 @@
 static void
 sldestroy(struct sl_softc *sc)
 {
+
+	/*
+	 * XXXRW: Slight race here: we may detach bpf/if before we
+	 * attach.  This appears to be a property of the unit selection
+	 * process, which might be better handled by the interface
+	 * cloning subsystem?
+	 */
 	bpfdetach(&sc->sc_if);
 	if_detach(&sc->sc_if);
+	mtx_lock(&slip_mtx);
 	LIST_REMOVE(sc, sl_next);
+	mtx_unlock(&slip_mtx);
 	m_free(sc->sc_mbuf);
+	mtx_destroy(&sc->sc_mtx);
 	mtx_destroy(&sc->sc_fastq.ifq_mtx);
 	if (sc->bpfbuf)
 		free(sc->bpfbuf, M_SL);
@@ -423,6 +442,10 @@
 	clist_free_cblocks(&tp->t_outq);
 	sc = (struct sl_softc *)tp->t_sc;
 	if (sc != NULL) {
+		/*
+		 * XXXRW: tear-down race between timeout and slclose()?
+		 */
+		mtx_lock(&sc->sc_mtx);
 		if (sc->sc_outfill) {
 			sc->sc_outfill = 0;
 			untimeout(sl_outfill, sc, sc->sc_ofhandle);
@@ -431,6 +454,7 @@
 			sc->sc_keepalive = 0;
 			untimeout(sl_keepalive, sc, sc->sc_kahandle);
 		}
+		mtx_unlock(&sc->sc_mtx);
 		if_down(&sc->sc_if);
 		sc->sc_ttyp = NULL;
 		tp->t_sc = NULL;
@@ -468,12 +492,21 @@
 			splx(s);
 			return (ENXIO);
 		}
+		/*
+		 * XXXRW: we hold the mutex over all of this to protect
+		 * the unit change and global list consistency.  However,
+		 * some of these functions probably sleep, making this
+		 * wrong.  If we have to support renumbering, we probably
+		 * need a way to reserve both numbers to prevent them
+		 * from being reused during the change, or a way to sleep
+		 * waiting for a change to end (i.e., a CV).
+		 */
+		mtx_lock(&slip_mtx);
 		if (sc->sc_if.if_dunit != unit) {
 			if (!slisunitfree(unit)) {
-				splx(s);
+				mtx_unlock(&slip_mtx);
 				return (ENXIO);
 			}
-
 			wasup = sc->sc_if.if_flags & IFF_UP;
 			bpfdetach(&sc->sc_if);
 			if_detach(&sc->sc_if);
@@ -491,9 +524,11 @@
 			    SLIP_HIWAT + 2 * sc->sc_if.if_mtu + 1);
 		}
 		slmarkstatic(unit);
+		mtx_unlock(&slip_mtx);
 		break;
 
 	case SLIOCSKEEPAL:
+		mtx_lock(&sc->sc_mtx);
 		sc->sc_keepalive = *(u_int *)data * hz;
 		if (sc->sc_keepalive) {
 			sc->sc_flags |= SC_KEEPALIVE;
@@ -505,6 +540,7 @@
 				sc->sc_flags &= ~SC_KEEPALIVE;
 			}
 		}
+		mtx_unlock(&sc->sc_mtx);
 		break;
 
 	case SLIOCGKEEPAL:
@@ -512,6 +548,7 @@
 		break;
 
 	case SLIOCSOUTFILL:
+		mtx_lock(&sc->sc_mtx);
 		sc->sc_outfill = *(u_int *)data * hz;
 		if (sc->sc_outfill) {
 			sc->sc_flags |= SC_OUTWAIT;
@@ -523,9 +560,11 @@
 				sc->sc_flags &= ~SC_OUTWAIT;
 			}
 		}
+		mtx_unlock(&sc->sc_mtx);
 		break;
 
 	case SLIOCGOUTFILL:
+		/* Unlocked read. */
 		*(int *)data = sc->sc_outfill / hz;
 		break;
 
@@ -595,9 +634,10 @@
 }
 
 /*
- * Start output on interface.  Get another datagram
- * to send from the interface queue and map it to
- * the interface before starting output.
+ * Start output on interface.  Get another datagram to send from the
+ * interface queue and map it to the interface before starting output.  Due
+ * to IFF_NEEDSGIANT, this code runs with Giant and can safely interface
+ * with the tty code.
  */
 static int
 slstart(tp)
@@ -621,8 +661,11 @@
 		(*tp->t_oproc)(tp);
 
 		if (tp->t_outq.c_cc != 0) {
-			if (sc != NULL)
+			if (sc != NULL) {
+				mtx_lock(&sc->sc_mtx);
 				sc->sc_flags &= ~SC_OUTWAIT;
+				mtx_unlock(&sc->sc_mtx);
+			}
 			if (tp->t_outq.c_cc > SLIP_HIWAT)
 				return 0;
 		}
@@ -652,6 +695,7 @@
 		 * queueing, and the connection id compression will get
 		 * munged when this happens.
 		 */
+		mtx_lock(&sc->sc_mtx);
 		if (sc->sc_if.if_bpf) {
 			/*
 			 * We need to save the TCP/IP header before it's
@@ -682,9 +726,10 @@
 		}
 		ip = mtod(m, struct ip *);
 		if (ip->ip_v == IPVERSION && ip->ip_p == IPPROTO_TCP) {
-			if (sc->sc_if.if_flags & SC_COMPRESS)
+			if (sc->sc_if.if_flags & SC_COMPRESS) {
 				*mtod(m, u_char *) |= sl_compress_tcp(m, ip,
 				    &sc->sc_comp, 1);
+			}
 		}
 		if (sc->sc_if.if_bpf && sc->bpfbuf) {
 			/*
@@ -696,6 +741,7 @@
 			bcopy(mtod(m, caddr_t), &sc->bpfbuf[SLX_CHDR], CHDR_LEN);
 			BPF_TAP(&sc->sc_if, sc->bpfbuf, len + SLIP_HDRLEN);
 		}
+		mtx_unlock(&sc->sc_mtx);
 
 		/*
 		 * If system is getting low on clists, just flush our
@@ -711,7 +757,9 @@
 			continue;
 		}
 
+		mtx_lock(&sc->sc_mtx);
 		sc->sc_flags &= ~SC_OUTWAIT;
+		mtx_unlock(&sc->sc_mtx);
 		/*
 		 * The extra FRAME_END will start up a new packet, and thus
 		 * will flush any accumulated garbage.  We do this whenever
@@ -801,6 +849,8 @@
 {
 	struct mbuf *m, *newm;
 
+	mtx_assert(&sc->sc_mtx, MA_OWNED);
+
 	MGETHDR(m, M_DONTWAIT, MT_DATA);
 	if (m == NULL)
 		return (NULL);
@@ -856,13 +906,16 @@
 	if (sc == NULL)
 		return 0;
 	if (c & TTY_ERRORMASK || (tp->t_state & TS_CONNECTED) == 0) {
+		mtx_lock(&sc->sc_mtx);
 		sc->sc_flags |= SC_ERROR;
+		mtx_unlock(&sc->sc_mtx);
 		return 0;
 	}
 	c &= TTY_CHARMASK;
 
 	++sc->sc_if.if_ibytes;
 
+	mtx_lock(&sc->sc_mtx);
 	if (sc->sc_if.if_flags & IFF_DEBUG) {
 		if (c == ABT_ESC) {
 			/*
@@ -881,6 +934,7 @@
 					sc->sc_starttime = time_second;
 				if (sc->sc_abortcount >= ABT_COUNT) {
 					slclose(tp,0);
+					mtx_unlock(&sc->sc_mtx);
 					return 0;
 				}
 			}
@@ -903,6 +957,7 @@
 
 	case FRAME_ESCAPE:
 		sc->sc_escape = 1;
+		mtx_unlock(&sc->sc_mtx);
 		return 0;
 
 	case FRAME_END:
@@ -987,6 +1042,7 @@
 	if (sc->sc_mp < sc->sc_ep) {
 		*sc->sc_mp++ = c;
 		sc->sc_escape = 0;
+		mtx_unlock(&sc->sc_mtx);
 		return 0;
 	}
 
@@ -998,6 +1054,7 @@
 newpack:
 	sc->sc_mp = sc->sc_buf = sc->sc_ep - SLRMAX;
 	sc->sc_escape = 0;
+	mtx_unlock(&sc->sc_mtx);
 	return 0;
 }
 
@@ -1081,6 +1138,7 @@
 {
 	struct sl_softc *sc = chan;
 
+	mtx_lock(&sc->sc_mtx);
 	if (sc->sc_keepalive) {
 		if (sc->sc_flags & SC_KEEPALIVE) {
 			if (sc->sc_ttyp->t_pgrp != NULL) {
@@ -1094,6 +1152,7 @@
 	} else {
 		sc->sc_flags &= ~SC_KEEPALIVE;
 	}
+	mtx_unlock(&sc->sc_mtx);
 }
 
 static void
@@ -1104,6 +1163,7 @@
 	register struct tty *tp = sc->sc_ttyp;
 	int s;
 
+	mtx_lock(&sc->sc_mtx);
 	if (sc->sc_outfill && tp != NULL) {
 		if (sc->sc_flags & SC_OUTWAIT) {
 			s = splimp ();
@@ -1117,4 +1177,5 @@
 	} else {
 		sc->sc_flags &= ~SC_OUTWAIT;
 	}
+	mtx_unlock(&sc->sc_mtx);
 }
--- //depot/vendor/freebsd/src/sys/net/if_slvar.h	2004/04/07 20:52:05
+++ //depot/user/rwatson/netperf/sys/net/if_slvar.h	2004/08/06 22:33:57
@@ -34,13 +34,16 @@
 #ifndef _NET_IF_SLVAR_H_
 #define _NET_IF_SLVAR_H_
 
+#include <sys/_mutex.h>
 #include <sys/callout.h>
 
 /*
  * Definitions for SLIP interface data structures
  *
  * (This exists so programs like slstats can get at the definition
- *  of sl_softc.)
+ *  of sl_softc.)  Fields owned by the SLIP subsystem are protected
+ * using sc_mtx, with the exception of sc_next, which is protected
+ * by the global slip_mtx.
  */
 struct sl_softc {
 	struct	ifnet sc_if;		/* network-visible interface */
@@ -66,6 +69,7 @@
 	struct	slcompress sc_comp;	/* tcp compression data */
 	LIST_ENTRY(sl_softc) sl_next;
 	u_char	*bpfbuf;		/* hang buffer for bpf here */
+	struct	mtx sc_mtx;
 };
 
 /* internal flags */
